Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent
Class ConcurrentHashMap

    java.lang.Object
      java.util.AbstractMap
          edu.emory.mathcs.backport.java.util.AbstractMap
              edu.emory.mathcs.backport.java.util.concurrent.ConcurrentHashMap

All Implemented Interfaces:
  ConcurrentMap, java.util.Map, java.io.Serializable

public class ConcurrentHashMap
extends AbstractMap
implements ConcurrentMap, java.io.Serializable

A hash table supporting full concurrency of retrievals and adjustable expected concurrency for updates. This class obeys the same functional specification as `Hashtable`, and includes versions of methods corresponding to each method of `Hashtable`. However, even though all operations are thread-safe, retrieval operations do not entail locking, and there is not any support for locking the entire table in a way that prevents all access. This class is fully interoperable with `Hashtable` in programs that rely on its thread safety but not on its synchronization details.

Retrieval operations (including `get`) generally do not block, so may overlap with update operations (including `put` and `remove`). Retrievals reflect the results of the most recently completed update operations holding upon their onset. For aggregate operations such as `putAll` and `clear`, concurrent retrievals may reflect insertion or removal of only some entries. Similarly, Iterators and Enumerations return elements reflecting the state of the hash table at some point at or since the creation of the iterator/enumeration. They do not throw `ConcurrentModificationException`. However, iterators are designed to be used by only one thread at a time.

The allowed concurrency among update operations is guided by the optional `concurrencyLevel` constructor argument (default `16`), which is used as a hint for internal sizing. The table is internally partitioned to try to permit the indicated number of concurrent updates without contention. Because placement in hash tables is essentially random, the actual concurrency will vary. Ideally, you should choose a value to accommodate as many threads as will ever concurrently modify the table. Using a significantly higher value than you need can waste space and time, and a significantly lower value can lead to thread contention. But overestimates and underestimates within an order of magnitude do not usually have much noticeable impact. A value of one is appropriate when it is known that only one thread will modify and all others will only read. Also, resizing this or any other kind of hash table is a relatively slow operation, so, when possible, it is a good idea to provide estimates of expected table sizes in constructors.

This class and its views and iterators implement all of the optional methods of the `Map` and `Iterator` interfaces.

Like `Hashtable` but unlike `HashMap`, this class does not allow `null` to be used as a key or value.

This class is a member of the Java Collections Framework.

Since:
  1.5
Author:
  Doug Lea
See Also:
  Serialized Form

Nested Class Summary

Nested classes inherited from class edu.emory.mathcs.backport.java.util.AbstractMap
`AbstractMap.SimpleEntry, AbstractMap.SimpleImmutableEntry`

Nested classes inherited from class java.util.Map
`java.util.Map.Entry`

Constructor Summary
`ConcurrentHashMap()` Creates a new, empty map with a default initial capacity (16), load factor (0.75) and concurrencyLevel (16).
`ConcurrentHashMap(int initialCapacity)` Creates a new, empty map with the specified initial capacity, and with default load factor (0.75) and concurrencyLevel (16).
`ConcurrentHashMap(int initialCapacity, float loadFactor)` Creates a new, empty map with the specified initial capacity and load factor and with the default concurrencyLevel (16).
`ConcurrentHashMap(int initialCapacity, float loadFactor, int concurrencyLevel)` Creates a new, empty map with the specified initial capacity, load factor and concurrency level.
`ConcurrentHashMap(java.util.Map m)` Creates a new map with the same mappings as the given map.

Method Summary
`void` | `clear()` Removes all of the mappings from this map.
`boolean` | `contains(java.lang.Object value)` Legacy method testing if some key maps into the specified value in this table.
`boolean` | `containsKey(java.lang.Object key)` Tests if the specified object is a key in this table.
`boolean` | `containsValue(java.lang.Object value)` Returns `true` if this map maps one or more keys to the specified value.
`java.util.Enumeration` | `elements()` Returns an enumeration of the values in this table.
`java.util.Set` | `entrySet()` Returns a `Set` view of the mappings contained in this map.
`java.lang.Object` | `get(java.lang.Object key)` Returns the value to which the specified key is mapped, or if this map contains no mapping for the key.
`boolean` | `isEmpty()` Returns `true` if this map contains no key-value mappings.
`java.util.Enumeration` | `keys()` Returns an enumeration of the keys in this table.
`java.util.Set` | `keySet()` Returns a `Set` view of the keys contained in this map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Maps the specified key to the specified value in this table.
`void` | `putAll(java.util.Map m)` Copies all of the mappings from the specified map to this one.
`java.lang.Object` | `putIfAbsent(java.lang.Object key, java.lang.Object value)` If the specified key is not already associated with a value, associate it with the given value. This is equivalent to
       if (!map.containsKey(key))
           return map.put(key, value);
       else
           return map.get(key);
except that the action is performed atomically.
`java.lang.Object` | `remove(java.lang.Object key)` Removes the key (and its corresponding value) from this map.
`boolean` | `remove(java.lang.Object key, java.lang.Object value)` Removes the entry for a key only if currently mapped to a given value. This is equivalent to
       if (map.containsKey(key) && map.get(key).equals(value)) {
           map.remove(key);
           return true;
       } else return false;
except that the action is performed atomically.
`java.lang.Object` | `replace(java.lang.Object key, java.lang.Object value)` Replaces the entry for a key only if currently mapped to some value. This is equivalent to
       if (map.containsKey(key)) {
           return map.put(key, value);
       } else return null;
except that the action is performed atomically.
`boolean` | `replace(java.lang.Object key, java.lang.Object oldValue, java.lang.Object newValue)` Replaces the entry for a key only if currently mapped to a given value. This is equivalent to
       if (map.containsKey(key) && map.get(key).equals(oldValue)) {
           map.put(key, newValue);
           return true;
       } else return false;
except that the action is performed atomically.
`int` | `size()` Returns the number of key-value mappings in this map.
`java.util.Collection` | `values()` Returns a `Collection` view of the values contained in this map.

Methods inherited from class java.util.AbstractMap
`clone, equals, hashCode, toString`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode`

Constructor Detail

### ConcurrentHashMap

    public ConcurrentHashMap(int initialCapacity,
                             float loadFactor,
                             int concurrencyLevel)

  Creates a new, empty map with the specified initial capacity, load factor and concurrency level.

Parameters:
  `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements.
  `loadFactor` - the load factor threshold, used to control resizing. Resizing may be performed when the average number of elements per bin exceeds this threshold.
  `concurrencyLevel` - the estimated number of concurrently updating threads. The implementation performs internal sizing to try to accommodate this many threads.
Throws:
  `java.lang.IllegalArgumentException` - if the initial capacity is negative or the load factor or concurrencyLevel are nonpositive.

### ConcurrentHashMap

    public ConcurrentHashMap(int initialCapacity,
                             float loadFactor)

  Creates a new, empty map with the specified initial capacity and load factor and with the default concurrencyLevel (16).

Parameters:
  `initialCapacity` - The implementation performs internal sizing to accommodate this many elements.
  `loadFactor` - the load factor threshold, used to control resizing. Resizing may be performed when the average number of elements per bin exceeds this threshold.
Throws:
  `java.lang.IllegalArgumentException` - if the initial capacity of elements is negative or the load factor is nonpositive
Since:
  1.6

### ConcurrentHashMap

    public ConcurrentHashMap(int initialCapacity)

  Creates a new, empty map with the specified initial capacity, and with default load factor (0.75) and concurrencyLevel (16).

Parameters:
  `initialCapacity` - the initial capacity. The implementation performs internal sizing to accommodate this many elements.
Throws:
  `java.lang.IllegalArgumentException` - if the initial capacity of elements is negative.

### ConcurrentHashMap

    public ConcurrentHashMap()

  Creates a new, empty map with a default initial capacity (16), load factor (0.75) and concurrencyLevel (16).

### ConcurrentHashMap

    public ConcurrentHashMap(java.util.Map m)

  Creates a new map with the same mappings as the given map. The map is created with a capacity of 1.5 times the number of mappings in the given map or 16 (whichever is greater), and a default load factor (0.75) and concurrencyLevel (16).

Parameters:
  `m` - the map

Method Detail

### isEmpty

    public boolean isEmpty()

  Returns `true` if this map contains no key-value mappings.

  Specified by:
    `isEmpty` in interface `java.util.Map`
  Returns:
    `true` if this map contains no key-value mappings

### size

    public int size()

  Returns the number of key-value mappings in this map. If the map contains more than `Integer.MAX_VALUE` elements, returns `Integer.MAX_VALUE`.

  Specified by:
    `size` in interface `java.util.Map`
  Returns:
    the number of key-value mappings in this map

### get

    public java.lang.Object get(java.lang.Object key)

  Returns the value to which the specified key is mapped, or if this map contains no mapping for the key.

  More formally, if this map contains a mapping from a key to a value such that , then this method returns ; otherwise it returns . (There can be at most one such mapping.)

  Specified by:
    `get` in interface `java.util.Map`
  Throws:
    `java.lang.NullPointerException` - if the specified key is null

### containsKey

    public boolean containsKey(java.lang.Object key)

  Tests if the specified object is a key in this table.

  Specified by:
    `containsKey` in interface `java.util.Map`
  Parameters:
    `key` - possible key
  Returns:
    `true` if and only if the specified object is a key in this table, as determined by the `equals` method; `false` otherwise.
  Throws:
    `java.lang.NullPointerException` - if the specified key is null

### containsValue

    public boolean containsValue(java.lang.Object value)

  Returns `true` if this map maps one or more keys to the specified value. Note: This method requires a full internal traversal of the hash table, and so is much slower than method `containsKey`.

  Specified by:
    `containsValue` in interface `java.util.Map`
  Parameters:
    `value` - value whose presence in this map is to be tested
  Returns:
    `true` if this map maps one or more keys to the specified value
  Throws:
    `java.lang.NullPointerException` - if the specified value is null

### contains

    public boolean contains(java.lang.Object value)

  Legacy method testing if some key maps into the specified value in this table. This method is identical in functionality to `containsValue(java.lang.Object)`, and exists solely to ensure full compatibility with class `Hashtable`, which supported this method prior to introduction of the Java Collections framework.

  Parameters:
    `value` - a value to search for
  Returns:
    `true` if and only if some key maps to the `value` argument in this table as determined by the `equals` method; `false` otherwise
  Throws:
    `java.lang.NullPointerException` - if the specified value is null

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Maps the specified key to the specified value in this table. Neither the key nor the value can be null.

  The value can be retrieved by calling the `get` method with a key that is equal to the original key.

  Specified by:
    `put` in interface `java.util.Map`
  Parameters:
    `key` - key with which the specified value is to be associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with `key`, or `null` if there was no mapping for `key`
  Throws:
    `java.lang.NullPointerException` - if the specified key or value is null

### putIfAbsent

    public java.lang.Object putIfAbsent(java.lang.Object key,
                                        java.lang.Object value)

  If the specified key is not already associated with a value, associate it with the given value. This is equivalent to

         if (!map.containsKey(key))
             return map.put(key, value);
         else
             return map.get(key);

  except that the action is performed atomically.

  Specified by:
    `putIfAbsent` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is to be associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.NullPointerException` - if the specified key or value is null

### putAll

    public void putAll(java.util.Map m)

  Copies all of the mappings from the specified map to this one. These mappings replace any mappings that this map had for any of the keys currently in the specified map.

  Specified by:
    `putAll` in interface `java.util.Map`
  Parameters:
    `m` - mappings to be stored in this map

### remove

    public java.lang.Object remove(java.lang.Object key)

  Removes the key (and its corresponding value) from this map. This method does nothing if the key is not in the map.

  Specified by:
    `remove` in interface `java.util.Map`
  Parameters:
    `key` - the key that needs to be removed
  Returns:
    the previous value associated with `key`, or `null` if there was no mapping for `key`
  Throws:
    `java.lang.NullPointerException` - if the specified key is null

### remove

    public boolean remove(java.lang.Object key,
                          java.lang.Object value)

  Removes the entry for a key only if currently mapped to a given value. This is equivalent to

         if (map.containsKey(key) && map.get(key).equals(value)) {
             map.remove(key);
             return true;
         } else return false;

  except that the action is performed atomically.

  Specified by:
    `remove` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `value` - value expected to be associated with the specified key
  Returns:
    `true` if the value was removed
  Throws:
    `java.lang.NullPointerException` - if the specified key is null

### replace

    public boolean replace(java.lang.Object key,
                           java.lang.Object oldValue,
                           java.lang.Object newValue)

  Replaces the entry for a key only if currently mapped to a given value. This is equivalent to

         if (map.containsKey(key) && map.get(key).equals(oldValue)) {
             map.put(key, newValue);
             return true;
         } else return false;

  except that the action is performed atomically.

  Specified by:
    `replace` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `oldValue` - value expected to be associated with the specified key
    `newValue` - value to be associated with the specified key
  Returns:
    `true` if the value was replaced
  Throws:
    `java.lang.NullPointerException` - if any of the arguments are null

### replace

    public java.lang.Object replace(java.lang.Object key,
                                    java.lang.Object value)

  Replaces the entry for a key only if currently mapped to some value. This is equivalent to

         if (map.containsKey(key)) {
             return map.put(key, value);
         } else return null;

  except that the action is performed atomically.

  Specified by:
    `replace` in interface `ConcurrentMap`
  Parameters:
    `key` - key with which the specified value is associated
    `value` - value to be associated with the specified key
  Returns:
    the previous value associated with the specified key, or `null` if there was no mapping for the key
  Throws:
    `java.lang.NullPointerException` - if the specified key or value is null

### clear

    public void clear()

  Removes all of the mappings from this map.

  Specified by:
    `clear` in interface `java.util.Map`

### keySet

    public java.util.Set keySet()

  Returns a `Set` view of the keys contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `keySet` in interface `java.util.Map`
  Overrides:
    `keySet` in class `AbstractMap`

### values

    public java.util.Collection values()

  Returns a `Collection` view of the values contained in this map. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. The collection supports element removal, which removes the corresponding mapping from this map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `values` in interface `java.util.Map`

### entrySet

    public java.util.Set entrySet()

  Returns a `Set` view of the mappings contained in this map. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.

  The view's `iterator` is a "weakly consistent" iterator that will never throw `ConcurrentModificationException`, and guarantees to traverse elements as they existed upon construction of the iterator, and may (but is not guaranteed to) reflect any modifications subsequent to construction.

  Specified by:
    `entrySet` in interface `java.util.Map`

### keys

    public java.util.Enumeration keys()

  Returns an enumeration of the keys in this table.

  Returns:
    an enumeration of the keys in this table
  See Also:
    `keySet()`

### elements

    public java.util.Enumeration elements()

  Returns an enumeration of the values in this table.

  Returns:
    an enumeration of the values in this table
  See Also:
    `values()`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD